#include <bits/stdc++.h>
using namespace std;
long long n, q, niz[200005], x, y, niz2[200005];

int main(){
   scanf("%lld", &n);
   for(int i=1; i<=n; i++){
      scanf("%lld", &niz[i]);
   }
   for(int i=1; i<n; i++){
      if(niz[i]>niz[i+1]) niz2[i]=niz2[i-1]+1;
      else niz2[i]=niz2[i-1];
   }
   for(int i=1; i<=n; i++) cout << niz2[i] << " ";
   cout << endl;
   scanf("%lld", &q);
   for(int i=1; i<=q; i++){
      scanf("%lld", &x);
      scanf("%lld", &y);
      if(niz2[y-1]-niz2[x-1]<=1){
         printf("DA");
         printf("\n");
      }
      else{
         printf("NE");
         printf("\n");
      }
   }
   return 0;
}